Index: issm/trunk/src/c/ModelProcessorx/DiagnosticStokes/CreateElementsNodesAndMaterialsDiagnosticStokes.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/DiagnosticStokes/CreateElementsNodesAndMaterialsDiagnosticStokes.cpp	(revision 464)
+++ issm/trunk/src/c/ModelProcessorx/DiagnosticStokes/CreateElementsNodesAndMaterialsDiagnosticStokes.cpp	(revision 465)
@@ -38,4 +38,5 @@
 
 	int         analysis_type;
+	int         sub_analysis_type;
 	
 	/*output: */
@@ -134,4 +135,5 @@
 	/*Get analysis_type: */
 	analysis_type=AnalysisTypeAsEnum(model->analysis_type);
+	sub_analysis_type=AnalysisTypeAsEnum(model->sub_analysis_type);
 
 	/*Width of elements: */
@@ -428,5 +430,5 @@
 
 	/*Get number of dofs per node: */
-	DistributeNumDofs(&node_numdofs,analysis_type);
+	DistributeNumDofs(&node_numdofs,analysis_type,sub_analysis_type);
 
 	for (i=0;i<model->numberofnodes;i++){
Index: issm/trunk/src/c/ModelProcessorx/DiagnosticVert/CreateElementsNodesAndMaterialsDiagnosticVert.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/DiagnosticVert/CreateElementsNodesAndMaterialsDiagnosticVert.cpp	(revision 464)
+++ issm/trunk/src/c/ModelProcessorx/DiagnosticVert/CreateElementsNodesAndMaterialsDiagnosticVert.cpp	(revision 465)
@@ -37,4 +37,5 @@
 
 	int         analysis_type;
+	int         sub_analysis_type;
 	
 	/*output: */
@@ -143,4 +144,5 @@
 	/*Get analysis_type: */
 	analysis_type=AnalysisTypeAsEnum(model->analysis_type);
+	sub_analysis_type=AnalysisTypeAsEnum(model->sub_analysis_type);
 
 	/*Width of elements: */
@@ -354,5 +356,5 @@
 	
 	/*Get number of dofs per node: */
-	DistributeNumDofs(&node_numdofs,analysis_type);
+	DistributeNumDofs(&node_numdofs,analysis_type,sub_analysis_type);
 
 	for (i=0;i<model->numberofnodes;i++){
Index: issm/trunk/src/c/ModelProcessorx/Model.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/Model.cpp	(revision 464)
+++ issm/trunk/src/c/ModelProcessorx/Model.cpp	(revision 465)
@@ -37,4 +37,5 @@
 	model->meshtype=NULL;
 	model->analysis_type=NULL;
+	model->sub_analysis_type=NULL;
 	model->numberofelements=0;
 	model->numberofnodes=0;
@@ -243,4 +244,5 @@
 	xfree((void**)&model->meshtype);
 	xfree((void**)&model->analysis_type);
+	xfree((void**)&model->sub_analysis_type);
 	
 	if(model->numrifts){
@@ -289,4 +291,5 @@
 	/*In ModelInit, we get all the data that is not difficult to get, and that is small: */
 	ModelFetchData((void**)&model->analysis_type,NULL,NULL,model_handle,"analysis_type","String",NULL); 
+	ModelFetchData((void**)&model->sub_analysis_type,NULL,NULL,model_handle,"sub_analysis_type","String",NULL); 
 
 	ModelFetchData((void**)&model->meshtype,NULL,NULL,model_handle,"type","String",NULL);
Index: issm/trunk/src/c/ModelProcessorx/Model.h
===================================================================
--- issm/trunk/src/c/ModelProcessorx/Model.h	(revision 464)
+++ issm/trunk/src/c/ModelProcessorx/Model.h	(revision 465)
@@ -16,4 +16,5 @@
 	char*   meshtype;
 	char*   analysis_type;
+	char*   sub_analysis_type;
 	char*   solverstring;
 
@@ -174,7 +175,5 @@
 
 	/*Creation of fem datasets: general drivers*/
-	void	CreateElementsNodesAndMaterials(DataSet** pelements,DataSet** pnodes, DataSet** pmaterials, Model* model,ConstDataHandle model_handle);
-	void    CreateConstraints(DataSet** pconstraints, Model* model,ConstDataHandle model_handle);
-	void    CreateLoads(DataSet** ploads, Model* model, ConstDataHandle model_handle);
+	void    CreateDataSets(DataSet** pelements,DataSet** pnodes, DataSet** pmaterials, DataSet** pconstraints, DataSet** ploads,DataSet** pparameters,Model* model,ConstDataHandle model_handle);
 	void    CreateParameters(DataSet** pparameters,Model* model,ConstDataHandle model_handle);
 
@@ -186,5 +185,5 @@
 	void	CreateConstraintsDiagnosticHoriz(DataSet** pconstraints,Model* model,ConstDataHandle model_handle);
 	void    CreateLoadsDiagnosticHoriz(DataSet** ploads, Model* model, ConstDataHandle model_handle);
-	void    CreateParametersDiagnosticHoriz(DataSet* parameters,Model* model,ConstDataHandle model_handle,int* pcount);
+	void    CreateParametersDiagnosticHoriz(DataSet** pparameters,Model* model,ConstDataHandle model_handle);
 
 	/*diagnostic vertical*/
@@ -192,5 +191,4 @@
 	void	CreateConstraintsDiagnosticVert(DataSet** pconstraints,Model* model,ConstDataHandle model_handle);
 	void    CreateLoadsDiagnosticVert(DataSet** ploads, Model* model, ConstDataHandle model_handle);
-	void    CreateParametersDiagnosticVert(DataSet* parameters,Model* model,ConstDataHandle model_handle,int* pcount);
 
 	/*diagnostic hutter*/
@@ -198,5 +196,4 @@
 	void	CreateConstraintsDiagnosticHutter(DataSet** pconstraints,Model* model,ConstDataHandle model_handle);
 	void    CreateLoadsDiagnosticHutter(DataSet** ploads, Model* model, ConstDataHandle model_handle);
-	void    CreateParametersDiagnosticHutter(DataSet* parameters,Model* model,ConstDataHandle model_handle,int* pcount);
 
 	/*diagnostic stokes*/
@@ -204,5 +201,4 @@
 	void	CreateConstraintsDiagnosticStokes(DataSet** pconstraints,Model* model,ConstDataHandle model_handle);
 	void    CreateLoadsDiagnosticStokes(DataSet** ploads, Model* model, ConstDataHandle model_handle);
-	void    CreateParametersDiagnosticStokes(DataSet* parameters,Model* model,ConstDataHandle model_handle,int* pcount);
 
 	/*slope compute*/
@@ -210,8 +206,7 @@
 	void	CreateConstraintsSlopeCompute(DataSet** pconstraints,Model* model,ConstDataHandle model_handle);
 	void    CreateLoadsSlopeCompute(DataSet** ploads, Model* model, ConstDataHandle model_handle);
-	void    CreateParametersSlopeCompute(DataSet* parameters,Model* model,ConstDataHandle model_handle,int* pcount);
 
 	/*control:*/
-	void    CreateParametersControl(DataSet* parameters,Model* model,ConstDataHandle model_handle,int* pcount);
+	void    CreateParametersControl(DataSet** pparameters,Model* model,ConstDataHandle model_handle);
 
 
Index: issm/trunk/src/c/ModelProcessorx/SlopeCompute/CreateElementsNodesAndMaterialsSlopeCompute.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/SlopeCompute/CreateElementsNodesAndMaterialsSlopeCompute.cpp	(revision 464)
+++ issm/trunk/src/c/ModelProcessorx/SlopeCompute/CreateElementsNodesAndMaterialsSlopeCompute.cpp	(revision 465)
@@ -36,4 +36,5 @@
 
 	int         analysis_type;
+	int         sub_analysis_type;
 	
 	/*output: */
@@ -131,4 +132,5 @@
 	/*Get analysis_type: */
 	analysis_type=AnalysisTypeAsEnum(model->analysis_type);
+	sub_analysis_type=AnalysisTypeAsEnum(model->sub_analysis_type);
 
 	/*Width of elements: */
@@ -397,5 +399,5 @@
 
 	/*Get number of dofs per node: */
-	DistributeNumDofs(&node_numdofs,analysis_type);
+	DistributeNumDofs(&node_numdofs,analysis_type,sub_analysis_type);
 
 	for (i=0;i<model->numberofnodes;i++){
Index: issm/trunk/src/c/PenaltyConstraintsx/PenaltyConstraintsx.cpp
===================================================================
--- issm/trunk/src/c/PenaltyConstraintsx/PenaltyConstraintsx.cpp	(revision 464)
+++ issm/trunk/src/c/PenaltyConstraintsx/PenaltyConstraintsx.cpp	(revision 465)
@@ -14,5 +14,5 @@
 
 void PenaltyConstraintsx(int* pconverged, int* pnum_unstable_constraints, DataSet* elements,DataSet* nodes,
-		DataSet* loads,DataSet* materials, ParameterInputs* inputs,int analysis_type){
+		DataSet* loads,DataSet* materials, ParameterInputs* inputs,int analysis_type,int sub_analysis_type){
 
 	int i;
@@ -31,8 +31,8 @@
 	 * management routine, otherwise, skip : */
 	if (loads->RiftIsPresent()){
-		loads->RiftConstraints(&num_unstable_constraints,inputs,analysis_type);
+		loads->RiftConstraints(&num_unstable_constraints,inputs,analysis_type,sub_analysis_type);
 	}
 	else if(loads->MeltingIsPresent()){
-		loads->MeltingConstraints(&num_unstable_constraints,inputs,analysis_type);
+		loads->MeltingConstraints(&num_unstable_constraints,inputs,analysis_type,sub_analysis_type);
 	}
 	else{
Index: issm/trunk/src/c/PenaltyConstraintsx/PenaltyConstraintsx.h
===================================================================
--- issm/trunk/src/c/PenaltyConstraintsx/PenaltyConstraintsx.h	(revision 464)
+++ issm/trunk/src/c/PenaltyConstraintsx/PenaltyConstraintsx.h	(revision 465)
@@ -11,5 +11,5 @@
 /* local prototypes: */
 void PenaltyConstraintsx(int* pconverged, int* pnum_unstable_constraints, DataSet* elements,DataSet* nodes,
-		DataSet* loads,DataSet* materials, ParameterInputs* inputs,int analysis_type); 
+		DataSet* loads,DataSet* materials, ParameterInputs* inputs,int analysis_type,int sub_analysis_type); 
 
 #endif  /* _PENALTYCONSTRAINTSX_H */
Index: issm/trunk/src/c/PenaltySystemMatricesx/PenaltySystemMatricesx.cpp
===================================================================
--- issm/trunk/src/c/PenaltySystemMatricesx/PenaltySystemMatricesx.cpp	(revision 464)
+++ issm/trunk/src/c/PenaltySystemMatricesx/PenaltySystemMatricesx.cpp	(revision 465)
@@ -14,5 +14,5 @@
 
 void PenaltySystemMatricesx(Mat Kgg, Vec pg,DataSet* elements,DataSet* nodes,DataSet* loads,DataSet* materials,
-		int kflag,int pflag,ParameterInputs* inputs,int analysis_type){
+		int kflag,int pflag,ParameterInputs* inputs,int analysis_type,int sub_analysis_type){
 	
 	int i;
@@ -33,6 +33,6 @@
 
 	/*Add penalties to stiffnesses, from loads: */
-	if(kflag)loads->PenaltyCreateKMatrix(Kgg,inputs,kmax,analysis_type);
-	if(pflag)loads->PenaltyCreatePVector(pg,inputs,kmax,analysis_type);
+	if(kflag)loads->PenaltyCreateKMatrix(Kgg,inputs,kmax,analysis_type,sub_analysis_type);
+	if(pflag)loads->PenaltyCreatePVector(pg,inputs,kmax,analysis_type,sub_analysis_type);
 	
 	/*Assemble matrices: */
Index: issm/trunk/src/c/PenaltySystemMatricesx/PenaltySystemMatricesx.h
===================================================================
--- issm/trunk/src/c/PenaltySystemMatricesx/PenaltySystemMatricesx.h	(revision 464)
+++ issm/trunk/src/c/PenaltySystemMatricesx/PenaltySystemMatricesx.h	(revision 465)
@@ -11,5 +11,5 @@
 /* local prototypes: */
 void PenaltySystemMatricesx(Mat Kgg, Vec pg,DataSet* elements,DataSet* nodes,DataSet* loads,DataSet* materials,
-		int kflag,int pflag,ParameterInputs* inputs,int analysis_type); 
+		int kflag,int pflag,ParameterInputs* inputs,int analysis_type,int sub_analysis_type); 
 
 #endif  /* _PENALTYSYSTEMMATRICESX_H */
Index: issm/trunk/src/c/ProcessParamsx/ProcessParamsx.cpp
===================================================================
--- issm/trunk/src/c/ProcessParamsx/ProcessParamsx.cpp	(revision 464)
+++ issm/trunk/src/c/ProcessParamsx/ProcessParamsx.cpp	(revision 465)
@@ -54,9 +54,5 @@
 
 	
-	if (   (analysis_type==ControlAnalysisEnum()) || 
-	       (analysis_type==DiagnosticHorizAnalysisEnum()) || 
-	       (analysis_type==DiagnosticVertAnalysisEnum()) || 
-	       (analysis_type==DiagnosticStokesAnalysisEnum()) 
-	   ){
+	if (   (analysis_type==ControlAnalysisEnum()) ||  (analysis_type==DiagnosticAnalysisEnum())){
 
 		parameters->FindParam((void*)&vx,"vx");
Index: issm/trunk/src/c/SystemMatricesx/SystemMatricesx.cpp
===================================================================
--- issm/trunk/src/c/SystemMatricesx/SystemMatricesx.cpp	(revision 464)
+++ issm/trunk/src/c/SystemMatricesx/SystemMatricesx.cpp	(revision 465)
@@ -14,5 +14,5 @@
 
 void SystemMatricesx(Mat* pKgg, Vec* ppg,DataSet* elements,DataSet* nodes,DataSet* loads,DataSet* materials,
-		int kflag,int pflag,int connectivity,int numberofdofspernode,ParameterInputs* inputs,int analysis_type){
+		int kflag,int pflag,int connectivity,int numberofdofspernode,ParameterInputs* inputs,int analysis_type,int sub_analysis_type){
 	
 	int i;
@@ -40,10 +40,10 @@
 
 	/*Fill stiffness matrix and right hand side vector, from elements: */
-	if(kflag)elements->CreateKMatrix(Kgg,inputs,analysis_type);
-	if(pflag)elements->CreatePVector(pg,inputs,analysis_type);
+	if(kflag)elements->CreateKMatrix(Kgg,inputs,analysis_type,sub_analysis_type);
+	if(pflag)elements->CreatePVector(pg,inputs,analysis_type,sub_analysis_type);
 	
 	/*Fill stiffness matrix and right hand side vector, from loads: */
-	if(kflag)loads->CreateKMatrix(Kgg,inputs,analysis_type);
-	if(pflag)loads->CreatePVector(pg,inputs,analysis_type);
+	if(kflag)loads->CreateKMatrix(Kgg,inputs,analysis_type,sub_analysis_type);
+	if(pflag)loads->CreatePVector(pg,inputs,analysis_type,sub_analysis_type);
 
 	/*Assemble matrices: */
Index: issm/trunk/src/c/SystemMatricesx/SystemMatricesx.h
===================================================================
--- issm/trunk/src/c/SystemMatricesx/SystemMatricesx.h	(revision 464)
+++ issm/trunk/src/c/SystemMatricesx/SystemMatricesx.h	(revision 465)
@@ -11,5 +11,5 @@
 /* local prototypes: */
 void SystemMatricesx(Mat* pKgg, Vec* ppg,DataSet* elements,DataSet* nodes,DataSet* loads,DataSet* materials,
-		int kflag,int pflag,int connectivity,int numberofdofspernode,ParameterInputs* inputs,int analysis_type); 
+		int kflag,int pflag,int connectivity,int numberofdofspernode,ParameterInputs* inputs,int analysis_type,int sub_analysis_type); 
 
 #endif  /* _SYSTEMMATRICESX_H */
Index: issm/trunk/src/c/io/SerialFetchData.cpp
===================================================================
--- issm/trunk/src/c/io/SerialFetchData.cpp	(revision 464)
+++ issm/trunk/src/c/io/SerialFetchData.cpp	(revision 465)
@@ -27,12 +27,12 @@
 	int      outdataset_size;
 
-	double*  outmatrix=NULL;
-	Mat      outpetscmatrix=NULL;
+	double*  outmatrix;
+	Mat      outpetscmatrix;
 	double*  outmatrix_workspace=NULL;;
 	int      outmatrix_rows,outmatrix_cols;
 	int      petsc;
 
-	double*  outvector=NULL;
-	Vec      outpetscvector=NULL;
+	double*  outvector;
+	Vec      outpetscvector;
 	double*  outvector_workspace=NULL;
 	int      outvector_rows;
Index: issm/trunk/src/c/objects/Beam.cpp
===================================================================
--- issm/trunk/src/c/objects/Beam.cpp	(revision 464)
+++ issm/trunk/src/c/objects/Beam.cpp	(revision 465)
@@ -212,11 +212,15 @@
 #define __FUNCT__ "Beam::CreateKMatrix"
 
-void  Beam::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type){
+void  Beam::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type){
 
 	/*Just branch to the correct element stiffness matrix generator, according to the type of analysis we are carrying out: */
-	if (analysis_type==DiagnosticHutterAnalysisEnum()) {
-
-		CreateKMatrixDiagnosticHutter( Kgg,inputs,analysis_type);
-
+	if (analysis_type==DiagnosticAnalysisEnum()) {
+	
+		if (sub_analysis_type==HutterAnalysisEnum()) {
+
+			CreateKMatrixDiagnosticHutter( Kgg,inputs,analysis_type,sub_analysis_type);
+		}
+		else 
+			throw ErrorException(__FUNCT__,exprintf("%s%i%s\n","sub_analysis_type: ",sub_analysis_type," not supported yet"));
 	}
 	else{
@@ -230,5 +234,5 @@
 #define __FUNCT__ "Beam::CreateKMatrixDiagnosticHutter"
 
-void  Beam::CreateKMatrixDiagnosticHutter(Mat Kgg,void* vinputs,int analysis_type){
+void  Beam::CreateKMatrixDiagnosticHutter(Mat Kgg,void* vinputs,int analysis_type,int sub_analysis_type){
 	
 	
@@ -265,9 +269,13 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Beam::CreatePVector"
-void  Beam::CreatePVector(Vec pg,void* inputs,int analysis_type){
+void  Beam::CreatePVector(Vec pg,void* inputs,int analysis_type,int sub_analysis_type){
 	
 	/*Just branch to the correct load generator, according to the type of analysis we are carrying out: */
-	if (analysis_type==DiagnosticHutterAnalysisEnum()) {
-		CreatePVectorDiagnosticHutter( pg,inputs,analysis_type);
+	if (analysis_type==DiagnosticAnalysisEnum()) {
+		if (sub_analysis_type==HutterAnalysisEnum()) {
+			CreatePVectorDiagnosticHutter( pg,inputs,analysis_type,sub_analysis_type);
+		}
+		else
+			throw ErrorException(__FUNCT__,exprintf("%s%i%s"," analysis ",analysis_type," not supported yet"));
 	}
 	else{
@@ -281,5 +289,5 @@
 #define __FUNCT__ "Beam::CreatePVectorDiagnosticHutter"
 
-void Beam::CreatePVectorDiagnosticHutter( Vec pg, void* vinputs, int analysis_type){
+void Beam::CreatePVectorDiagnosticHutter( Vec pg, void* vinputs, int analysis_type,int sub_analysis_type){
 
 	int i,j,k;
@@ -534,25 +542,25 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Beam::Du"
-void  Beam::Du(_p_Vec*, double*, double*, void*, int){
+void  Beam::Du(_p_Vec*, double*, double*, void*, int,int){
 	throw ErrorException(__FUNCT__," not supported yet!");
 }
 #undef __FUNCT__ 
 #define __FUNCT__ "Beam::Gradj"
-void  Beam::Gradj(_p_Vec*, double*, double*, void*, int, char*){
+void  Beam::Gradj(_p_Vec*, double*, double*, void*, int, int,char*){
 	throw ErrorException(__FUNCT__," not supported yet!");
 }
 #undef __FUNCT__ 
 #define __FUNCT__ "Beam::GradjDrag"
-void  Beam::GradjDrag(_p_Vec*, double*, double*, void*, int){
+void  Beam::GradjDrag(_p_Vec*, double*, double*, void*, int,int ){
 	throw ErrorException(__FUNCT__," not supported yet!");
 }
 #undef __FUNCT__ 
 #define __FUNCT__ "Beam::GradjB"
-void  Beam::GradjB(_p_Vec*, double*, double*, void*, int){
+void  Beam::GradjB(_p_Vec*, double*, double*, void*, int, int){
 	throw ErrorException(__FUNCT__," not supported yet!");
 }
 #undef __FUNCT__ 
 #define __FUNCT__ "Beam::Misfit"
-double Beam::Misfit(double*, double*, void*, int){
+double Beam::Misfit(double*, double*, void*, int,int ){
 	throw ErrorException(__FUNCT__," not supported yet!");
 }
Index: issm/trunk/src/c/objects/Beam.h
===================================================================
--- issm/trunk/src/c/objects/Beam.h	(revision 464)
+++ issm/trunk/src/c/objects/Beam.h	(revision 465)
@@ -56,12 +56,12 @@
 		int   MyRank();
 		void  Configure(void* loads,void* nodes,void* materials);
-		void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type);
-		void  CreatePVector(Vec pg, void* inputs, int analysis_type);
+		void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type);
+		void  CreatePVector(Vec pg, void* inputs, int analysis_type,int sub_analysis_type);
 		void  UpdateFromInputs(void* inputs);
 		void  GetDofList(int* doflist,int* pnumberofdofs);
 		void  GetDofList1(int* doflist);
-		void  CreateKMatrixDiagnosticHutter(Mat Kgg,void* inputs,int analysis_type);
+		void  CreateKMatrixDiagnosticHutter(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type);
 		void  GetParameterValue(double* pp, double* plist, double* gauss_l1l2l3);
-		void  CreatePVectorDiagnosticHutter(Vec pg,void* inputs,int analysis_type);
+		void  CreatePVectorDiagnosticHutter(Vec pg,void* inputs,int analysis_type,int sub_analysis_type);
 		void* GetMatPar();
 
@@ -78,9 +78,9 @@
 		void  GetBedList(double*);
 		void  GetThicknessList(double* thickness_list);
-		void  Du(_p_Vec*, double*, double*, void*, int);
-		void  Gradj(_p_Vec*, double*, double*, void*, int, char*);
-		void  GradjDrag(_p_Vec*, double*, double*, void*, int);
-		void  GradjB(_p_Vec*, double*, double*, void*, int);
-		double Misfit(double*, double*, void*, int);
+		void  Du(_p_Vec*, double*, double*, void*, int,int);
+		void  Gradj(_p_Vec*, double*, double*, void*, int, int,char*);
+		void  GradjDrag(_p_Vec*, double*, double*, void*, int,int );
+		void  GradjB(_p_Vec*, double*, double*, void*, int,int );
+		double Misfit(double*, double*, void*, int,int );
 		void  GetNodalFunctions(double* l1l2, double gauss_coord);
 		void  GetParameterValue(double* pvalue, double* value_list,double gauss_coord);
Index: issm/trunk/src/c/objects/Element.h
===================================================================
--- issm/trunk/src/c/objects/Element.h	(revision 464)
+++ issm/trunk/src/c/objects/Element.h	(revision 465)
@@ -24,6 +24,6 @@
 		virtual void  Demarshall(char** pmarshalled_dataset)=0;
 		virtual void  Configure(void* loads,void* nodes,void* materials)=0;
-		virtual void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type)=0;
-		virtual void  CreatePVector(Vec pg, void* inputs, int analysis_type)=0;
+		virtual void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type)=0;
+		virtual void  CreatePVector(Vec pg, void* inputs, int analysis_type,int sub_analysis_type)=0;
 		virtual void  UpdateFromInputs(void* inputs)=0;
 		virtual void  GetNodes(void** nodes)=0;
@@ -33,9 +33,9 @@
 		virtual void  GetThicknessList(double* thickness_list)=0;
 		virtual void  GetBedList(double* bed_list)=0;
-		virtual void  Du(Vec du_g,double* u_g,double* u_g_obs,void* inputs,int analysis_type)=0;
-		virtual void  Gradj(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type,char* control_type)=0;
-		virtual void  GradjDrag(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type)=0;
-		virtual void  GradjB(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type)=0;
-        virtual double Misfit(double* u_g,double* u_g_obs,void* inputs,int analysis_type)=0;
+		virtual void  Du(Vec du_g,double* u_g,double* u_g_obs,void* inputs,int analysis_type,int sub_analysis_type)=0;
+		virtual void  Gradj(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type,int sub_analysis_type,char* control_type)=0;
+		virtual void  GradjDrag(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type,int sub_analysis_type)=0;
+		virtual void  GradjB(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type,int sub_analysis_type)=0;
+        virtual double Misfit(double* u_g,double* u_g_obs,void* inputs,int analysis_type,int sub_analysis_type)=0;
         virtual void  ComputePressure(Vec p_g)=0;
 
Index: issm/trunk/src/c/objects/Icefront.cpp
===================================================================
--- issm/trunk/src/c/objects/Icefront.cpp	(revision 464)
+++ issm/trunk/src/c/objects/Icefront.cpp	(revision 465)
@@ -199,5 +199,5 @@
 	return my_rank; 
 }
-void  Icefront::DistributeNumDofs(int* numdofspernode,int analysis_type){return;}
+void  Icefront::DistributeNumDofs(int* numdofspernode,int analysis_type,int sub_analysis_type){return;}
 		
 #undef __FUNCT__ 
@@ -240,5 +240,5 @@
 #define __FUNCT__ "Icefront::CreateKMatrix"
 
-void  Icefront::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type){
+void  Icefront::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type){
 
 	/*No stiffness loads applied, do nothing: */
@@ -250,13 +250,26 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Icefront::CreatePVector"
-void  Icefront::CreatePVector(Vec pg, void* inputs, int analysis_type){
+void  Icefront::CreatePVector(Vec pg, void* inputs, int analysis_type,int sub_analysis_type){
 
 	/*Just branch to the correct element icefront vector generator, according to the type of analysis we are carrying out: */
-	if ((analysis_type==DiagnosticHorizAnalysisEnum()) || (analysis_type==ControlAnalysisEnum())){
-		CreatePVectorDiagnosticHoriz( pg,inputs,analysis_type);
-	}
-	else if ((analysis_type==DiagnosticStokesAnalysisEnum())){
-
-		CreatePVectorDiagnosticStokes( pg,inputs,analysis_type);
+	if (analysis_type==ControlAnalysisEnum()){
+		
+		CreatePVectorDiagnosticHoriz( pg,inputs,analysis_type,sub_analysis_type);
+
+	}
+	else if (analysis_type==DiagnosticAnalysisEnum()){
+	
+		if (sub_analysis_type==HorizAnalysisEnum()){
+		
+			CreatePVectorDiagnosticHoriz( pg,inputs,analysis_type,sub_analysis_type);
+
+		}
+		else if (sub_analysis_type==StokesAnalysisEnum()){
+			
+			CreatePVectorDiagnosticStokes( pg,inputs,analysis_type,sub_analysis_type);
+
+		}
+		else throw ErrorException(__FUNCT__,exprintf("%s%i%s"," sub_analysis_type: ",sub_analysis_type," not supported yet"));
+
 	}
 	else{
@@ -268,12 +281,12 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Icefront::CreatePVectorDiagnosticHoriz"
-void Icefront::CreatePVectorDiagnosticHoriz( Vec pg, void* inputs, int analysis_type){
+void Icefront::CreatePVectorDiagnosticHoriz( Vec pg, void* inputs, int analysis_type,int sub_analysis_type){
 
 	/*Branck on the type of icefront: */
 	if (strcmp(type,"segment")==0){
-		CreatePVectorDiagnosticHorizSegment(pg,inputs,analysis_type);
+		CreatePVectorDiagnosticHorizSegment(pg,inputs,analysis_type,sub_analysis_type);
 	}
 	else{
-		CreatePVectorDiagnosticHorizQuad(pg,inputs,analysis_type);
+		CreatePVectorDiagnosticHorizQuad(pg,inputs,analysis_type,sub_analysis_type);
 	}
 }	
@@ -282,5 +295,5 @@
 #define __FUNCT__ "Icefront::CreatePVectorDiagnosticHorizSegment"
 
-void Icefront::CreatePVectorDiagnosticHorizSegment( Vec pg,void* vinputs, int analysis_type){
+void Icefront::CreatePVectorDiagnosticHorizSegment( Vec pg,void* vinputs, int analysis_type,int sub_analysis_type){
 
 	int i,j;
@@ -395,5 +408,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Icefont::CreatePVectorDiagnosticHorizQuad"
-void Icefront::CreatePVectorDiagnosticHorizQuad( Vec pg,void* vinputs, int analysis_type){
+void Icefront::CreatePVectorDiagnosticHorizQuad( Vec pg,void* vinputs, int analysis_type,int sub_analysis_type){
 
 	int i,j;
@@ -557,5 +570,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Icefont::CreatePVectorDiagnosticStokes"
-void Icefront::CreatePVectorDiagnosticStokes( Vec pg,void* vinputs, int analysis_type){
+void Icefront::CreatePVectorDiagnosticStokes( Vec pg,void* vinputs, int analysis_type,int sub_analysis_type){
 
 	int i,j;
@@ -853,5 +866,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Icefront::PenaltyCreateKMatrix"
-void  Icefront::PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type){
+void  Icefront::PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type,int sub_analysis_type){
 	/*do nothing: */
 }
@@ -859,5 +872,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Icefront::PenaltyCreatePVector"
-void  Icefront::PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type){
+void  Icefront::PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type,int sub_analysis_type){
 	/*do nothing: */
 }
Index: issm/trunk/src/c/objects/Icefront.h
===================================================================
--- issm/trunk/src/c/objects/Icefront.h	(revision 464)
+++ issm/trunk/src/c/objects/Icefront.h	(revision 465)
@@ -55,14 +55,14 @@
 		int   GetId(); 
 		int   MyRank();
-		void  DistributeNumDofs(int* numdofspernode,int analysis_type);
+		void  DistributeNumDofs(int* numdofspernode,int analysis_type,int sub_analysis_type);
 		void  Configure(void* elements,void* nodes,void* materials);
-		void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type);
+		void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type);
 		void  UpdateFromInputs(void* inputs);
 		
-		void  CreatePVector(Vec pg, void* inputs, int analysis_type);
-		void  CreatePVectorDiagnosticHoriz( Vec pg, void* inputs, int analysis_type);
-		void  CreatePVectorDiagnosticHorizSegment( Vec pg,void* inputs, int analysis_type);
-		void  CreatePVectorDiagnosticHorizQuad( Vec pg,void* inputs, int analysis_type);
-		void  CreatePVectorDiagnosticStokes( Vec pg,void* inputs, int analysis_type);
+		void  CreatePVector(Vec pg, void* inputs, int analysis_type,int sub_analysis_type);
+		void  CreatePVectorDiagnosticHoriz( Vec pg, void* inputs, int analysis_type,int sub_analysis_type);
+		void  CreatePVectorDiagnosticHorizSegment( Vec pg,void* inputs, int analysis_type,int sub_analysis_type);
+		void  CreatePVectorDiagnosticHorizQuad( Vec pg,void* inputs, int analysis_type,int sub_analysis_type);
+		void  CreatePVectorDiagnosticStokes( Vec pg,void* inputs, int analysis_type,int sub_analysis_type);
 		void  GetDofList(int* doflist,int* pnumberofdofs);
 		void  SegmentPressureLoad(double* pe_g,double rho_water,double rho_ice,double gravity, double* thickness_list, double* bed_list, double* normal,double length,int fill);
@@ -71,6 +71,6 @@
 		void  QuadPressureLoadStokes(double* pe_g,double rho_water,double rho_ice,double gravity, double* thickness_list, double* bed_list, 
 		                              double* normal1,double* normal2,double* normal3,double* normal4,double* xyz_list, int fill);
-		void  PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type);
-		void  PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type);
+		void  PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type,int sub_analysis_type);
+		void  PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type,int sub_analysis_type);
 		Object* copy();
 };
Index: issm/trunk/src/c/objects/Load.h
===================================================================
--- issm/trunk/src/c/objects/Load.h	(revision 464)
+++ issm/trunk/src/c/objects/Load.h	(revision 465)
@@ -24,9 +24,9 @@
 		virtual void  Demarshall(char** pmarshalled_dataset)=0;
 		virtual void  Configure(void* elements,void* nodes,void* materials)=0;
-		virtual void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type)=0;
-		virtual void  CreatePVector(Vec pg, void* inputs, int analysis_type)=0;
+		virtual void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type)=0;
+		virtual void  CreatePVector(Vec pg, void* inputs, int analysis_type,int sub_analysis_type)=0;
 		virtual void  UpdateFromInputs(void* inputs)=0;
-		virtual void  PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type)=0;
-		virtual void  PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type)=0;
+		virtual void  PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type,int sub_analysis_type)=0;
+		virtual void  PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type,int sub_analysis_type)=0;
 
 		int           Enum();
Index: issm/trunk/src/c/objects/OptArgs.h
===================================================================
--- issm/trunk/src/c/objects/OptArgs.h	(revision 464)
+++ issm/trunk/src/c/objects/OptArgs.h	(revision 465)
@@ -20,4 +20,5 @@
 	mxArray* n;
 	mxArray* analysis_type;
+	mxArray* sub_analysis_type;
 
 };
